﻿var docRef = app.activeDocument;
    var fillColor = new SolidColor;
    var numOfColFigure = 3; // Number of figures in a row
    var numOfRowFigure = 3; // Number of rows with figures
    var squareDimension = 100; // Square side in pixels
    var spaser = 2; // Spacing between tiles


    //Create Progress Bar
    var progressValue = 100 / (numOfColFigure * numOfRowFigure);
    var win = new Window("palette", "ProgressBar", [150, 150, 600, 260]);
    win.pnl = win.add("panel", [10, 10, 440, 100], "Script Progress");
    win.pnl.progBar = win.pnl.add("progressbar", [20, 35, 410, 60], 0, 100);
    win.show();

    for (var row = 0; row < numOfRowFigure; row++) {
        for (var col = 0; col < numOfColFigure; col++) {

            drawTiles(col, row); // call the function to draw
            win.pnl.progBar.value += progressValue;// updating the progress bar
        }
    }

    function drawTiles(colPos, rowPos) {
        var layerRef = docRef.artLayers.add(); // create a new layer
        layerRef.activeLayer;
        fillColor.hsb.hue = getRandomInt(360); // Random color for the current tile
        fillColor.hsb.saturation = 61;
        fillColor.hsb.brightness = 60;

        var sendArr = []; // create an array for adding selection coordinates
//Create an array with coordinates for the selection and filling with color of the main square
        var curSidePos = squareDimension + spaser;
        sendArr[0] = [curSidePos * colPos, curSidePos * rowPos];
        sendArr[1] = [(curSidePos * colPos) + squareDimension, curSidePos * rowPos];
        sendArr[2] = [(curSidePos * colPos) + squareDimension, (curSidePos * rowPos) + squareDimension];
        sendArr[3] = [curSidePos * colPos, (curSidePos * rowPos) + squareDimension];

        docRef.selection.select(sendArr); // select by coordinates
        docRef.selection.fill(fillColor, ColorBlendMode.NORMAL, 100, false);// fill with color
        docRef.selection.deselect(); // reset selection

        var sendArr = []; // creation of an array for adding coordinates of the selection of tile edges (only one edge will be created, and it will change/transform depending on its position)
        sendArr[0] = [curSidePos * colPos, curSidePos * rowPos];
        sendArr[1] = [(curSidePos * colPos) + 10, curSidePos * rowPos + 10];
        sendArr[2] = [(curSidePos * colPos) + 10, (curSidePos * rowPos) + squareDimension - 10];
        sendArr[3] = [curSidePos * colPos, (curSidePos * rowPos) + squareDimension];

//changing (rotating, moving) the faces depending on their positions on the tile
        bigSide(sendArr, "left", 55);
        bigSide(sendArr, "top", 80);
        bigSide(sendArr, "right", 99);
        bigSide(sendArr, "bottom", 44);

// Combining the faces and body of the tile into a single layer.
        docRef.artLayers[0].merge();
        docRef.artLayers[0].merge();
        docRef.artLayers[0].merge();
        docRef.artLayers[0].merge();
// app refresh (redraw) to show intermediate results
        app.refresh();
    }

    function bigSide(pointArr, side, bright) {
        fillColor.hsb.brightness = bright; // Set the brightness of the side
        layerRef = docRef.artLayers.add(); // Create a new layer for the edge
        layerRef.activeLayer;

// Activate the selection on the coordinate array
        docRef.selection.select(pointArr);
        docRef.selection.fill(fillColor, ColorBlendMode.NORMAL, 100, false);

// apply transformations depending on the position
        if (side == "top") {
            docRef.selection.rotate(90, AnchorPosition.BOTTOMLEFT); // rotate
            docRef.selection.translate(0, -squareDimension); // change the position
        }

        if (side == "right") {
            docRef.selection.translate(new UnitValue(squareDimension, "px"), new UnitValue(0, "px"));
            docRef.selection.rotate(180, AnchorPosition.MIDDLELEFT);
        }
        if (side == "bottom") {
            docRef.selection.translate(new UnitValue(squareDimension / 2, "px"), new UnitValue(squareDimension / 2, "px"));
            docRef.selection.rotate(270, AnchorPosition.MIDDLELEFT);
        }


        docRef.selection.deselect();
    }

    // getting a random integer from 0 to max
    function getRandomInt(max) {
        return Math.floor(Math.random() * max);
    }